#!/bin/bash
#AlignClust CLustering alignments of ncRNA
#Author: Milad Miladi miladim@informatik.uni-freiburg.de
printf "AlignClust sequences.aln.fa \nUsage: Pipeline for AlignClust project.\n"
PETFOLD="/home/milad/software/PETfold/bin/PETfold"
aln_file=$1
rel_file="rel.pp"
PETfolder="PETfold_output"
seq_struct_folder="Alignments"
mkdir $PETfolder
mkdir $seq_struct_folder
echo "call PETfold on $aln_file"
$PETFOLD -f $aln_file -r $PETfolder/$rel_file > $PETfolder/petfold_output
echo "PETfold executed."
perl consensus_to_single_structures.pl -input-dir $PETfolder -result-dir $seq_struct_folder -cutoff-ratio-consensus 70 -cutoff-ratio-MFE 70 -debug



#stefan scripts for filtering suboptimal structures
time ~/software/PETfold/bin/PETfold  -f Tests/db/RFAM_rand/RF00273/RF00273.aln.fasta -o 10000 | awk '{if($1=="PETfold"){mea=$4};if($1~/^Score/){print mea,$3};if($1=="Suboptimal"){print $3,$4}}' | tr - . | sort -k2gr > testit
LINE=`~/software/bin/RNAdistance -Xf -Dh < testit | awk '{print $2,NR}' | sort -k1gr | awk '{print NR,$2,NR+$2}' | sort -k3g | cut -d" " -f2 | head -1`
head -${LINE} testit | tail -1

