 ##path to stockholm subalignments
benchmark_dir = '../..//data/20150213-rfam-clique/'
import os

import time
##SET LOGGER LEVEL
import logging
logger = logging.getLogger()
logger.setLevel(logging.INFO)

import glob
import re
##extract subalignment files, format eg.  RF00001.0, RF00001.29,...  
ffiles = sorted(glob.glob(benchmark_dir + "RF[0-9]*.*")) 
files = [os.path.basename(full_path) for full_path in ffiles]
families = set([re.sub(r'\.\d+$', '', fl) for fl in files])
print "#families:" , len(families)
print "#sub_families:" , len(files)
logging.info("LOGGER\n")

result_dict = dict()

##def method
def evaluate_family(arg):
    fam, qu = arg


    ## locating subalignments of fam
    sub_fams = sorted(glob.glob(benchmark_dir + fam + ".*"))
    sub_fams_joined = " ".join(sub_fams)
    pw_id_list = list()
    ##invoke alex legacy scripts
    seq_ident = !python ./legacy/compute-average-pairwise-sequence-identity.py  -f stockholm -p $sub_fams_joined 
    for s1 in range(len(sub_fams)):
        for s2 in range(s1+1,len(sub_fams)):
            pair = sub_fams[s1] + " " + sub_fams[s2]
            pw_ident_out = !python ./legacy/compute-average-pairwise-sequence-identity.py  -f stockholm  $pair
            pw_ident= pw_ident_out[0].split()[2] ##output format is seq1 seq2 identity
            pw_id_list.append(float(pw_ident))
            
    fam_count = 0
    fam_length = 0  
    for sub_fam in sub_fams:
        count = !cat $sub_fam | python ./legacy/count-sequences.py Stockholm
        length = !cat $sub_fam | python ./legacy/compute-average-sequence-length.py Stockholm    
        count_i = count[0];
        fam_count += int(count_i)
        fam_length += float(length[0])  
    avg_count = float(fam_count)/len(sub_fams)
    avg_length = float(fam_length)/len(sub_fams)
    
    ##  update progress queue
    qu.put(fam)
    
    return {'fam' : fam, 'count': avg_count, 'length' : avg_length, 'identity' : float(seq_ident[0]), 'pw-ids' : pw_id_list }
