#!/usr/bin/env bash
# Compares number of input Stockholm files and number of objects present in EDeN similarity matrix for
# given experiment.

experiment=20141030-cmf-CLIP-overlap-filtered

wdir=$(pwd)
indir=data/$experiment
outdir=results/$experiment

cd $outdir
for tarf in `find . -maxdepth 1 -mindepth 1 -name '*.tar.gz'`;
do
	#echo $tarf
	if [ ! -f $wdir/$indir/$tarf ];
	then
		>&2 echo "Did not find matching input and output file for $tarf."
		continue
	else
		echo "Found matching input and output file for $tarf."
	fi

	tarf_stripped=${tarf%.tar.gz}
	tar xzf $tarf
	wc -l $tarf_stripped/eval/$tarf_stripped.class	
	rm -rf $tarf_stripped

	cd $wdir/$indir
	tar xzf $tarf
	ls $tarf_stripped | wc -l
	rm -rf $tarf_stripped
	
	echo ""
	cd $wdir/$outdir
done
