#!/usr/bin/env bash
tar_dir=$1
report_file_basename=report-clustering.pdf
report_file=$tar_dir/$report_file_basename

OUT_FILE_ARRAY=()
for tarf in $tar_dir/*.tar.gz; 
do
	tarf_stripped=${tarf%.tar.gz}
	out_file=$tarf_stripped.pdf
	python bin/analysis/compile-plots.py $tarf $out_file
	if [ -f $out_file ];
	then
		OUT_FILE_ARRAY+=($out_file)
	fi
done

pdftk ${OUT_FILE_ARRAY[@]} cat output $report_file
