#!/usr/bin/env bash

# Filder all output is written to, also contains a README
out_folder=results/20141211-similarity-examples

ps_out_folder=$out_folder/postscript
mkdir -p $ps_out_folder

gspan_out_folder=$out_folder/gspan
mkdir -p $gspan_out_folder

# The GSPAN file to be used
gspan_file=results/20141119-UC-CON-all-motifs/UC-CON-all-motifs-logfoldchange-gt-2/UC-CON-all-motifs-logfoldchange-gt-2.gspan.gz

# Folder containing postscript alignments and structures
ps_folder=results/20141119-UC-CON-all-motifs/UC-CON-all-motifs-logfoldchange-gt-2/eval/R-output
ps_files=$ps_folder/*.ps

# Copy quantile pair annotation
cp results/20141119-UC-CON-all-motifs/UC-CON-all-motifs-logfoldchange-gt-2/eval/R-output/quantile-pairs.tsv $out_folder

# List of all CMfinder motif names
all_motif_names=
for ps_file_full in $ps_files
do
	ps_file_name=$(basename "$ps_file_full")
	ps_file_basename=${ps_file_name%.*.ps}
	basename_split=(${ps_file_basename//-/ })
	motif_name=${basename_split[${#basename_split[@]} - 1]}
	all_motif_names+=($motif_name)

	cp $ps_file_full $ps_out_folder/
done

# Unique lists of motifs
unique_motifs=$(echo "${all_motif_names[@]}" | tr ' ' '\n' | sort -u | tr '\n' ' ')

# Fetch alignmnets for motifs
# TODO modify and call: results/20141211-similarity-examples/generate-alignments.sh

# Generate GSPAN files from scratch by running RNAalignClust
# TODO modify and call: results/20141211-similarity-examples/compute-all-sim-matrices.sh

# Delete everything except useful temporary files.
# TODO
