library(plyr)
library(reshape)
#list all analysis files recursivley 
filenames=list.files("..", pattern="*.analysis_all",recursive=T,full.names = T)
#read and store all analysis files in dtaaframes
import.list <- llply(filenames, function(f) { read.table(f, col.names=c("metric", gsub("GSPAN_|.analysis_all", "", basename(f) ) )  ) })
#merge analysis tables based on their common metric column
evals <- Reduce(function(x, y){merge(x, y, all=T,by="metric")}, import.list, accumulate=F)
#trabspose matrix to have metrics as column headers instead of row names
tevals=setNames(data.frame(t(evals[,-1])), evals[,1])
#ploting

 require(ggplot2)

 melted <- melt(tevals);
 ggplot(melted,aes(x=variable,y=value,fill=eval_name,group=eval_name))+geom_bar(stat="identity",position=position_dodge())
  
  
 data(diamonds)
# check the dataset
head(diamonds)
# plot it 
ggplot(diamonds, aes(clarity, fill=cut)) + geom_bar(position="dodge") +
opts(title="Examplary Grouped Barplot")

