def read_nspdk_feature(feature_file):
    rows = list()
    cols = list()
    vals = list()
    nnz_per_row = list()
    with open(feature_file, 'rb') as f:
        nonzeros = 0
        for rownum, line in enumerate(f):
    #         if rownum >= 2:
    #             break
            for pair in line.split():
                pairparts = pair.split(":")
                assert(len(pairparts)==2)
                try:
                    colnum = int(pairparts[0])
                    value = float(pairparts[1])
    #                 print rownum, colnum, value
                except ValueError:
                    print "ERROR line:{} cannot parse pair: {}".format(rownum, pairparts)
                    sys.exit (-1)
    #             np.append(row_arr, [rownum])
    #             np.append(col_arr, [colnum])
    #             np.append(val_arr, [value])
                rows.append(rownum)
                cols.append(colnum)
                vals.append(value)
                nonzeros += 1
            # end for pair
            nnz_per_row.append(nonzeros)
        # end for line
    
    from scipy.sparse import csr_matrix
    sparse_mat = csr_matrix((vals, (rows, cols)))
    print "Shape: {} #non-zeros {} #non-zeros-per-row: {}".format(sparse_mat.shape, sparse_mat.nnz, 
                                                             sum(nnz_per_row)/max(1, len(nnz_per_row)))
    return sparse_mat
